// BufferMaster.h

#ifndef BufferMaster_h
#define BufferMaster_h

#ifndef Buffer_h
#include "Buffer.h"
#endif

/*
	A BufferMaster is the owner's interface to a Buffer.
*/

class BufferMaster: public Buffer
  {
	private:
		uint8 *start;

		// not implemented:
			BufferMaster( const BufferMaster& );
			void operator=( const BufferMaster& );
	
	public:
		BufferMaster()
		  : Buffer( Data() ),
			 start( 0 )
		  {}
		
		explicit BufferMaster( Data space )
		  : Buffer( space ),
			 start( space.Start() )
		  {}
		
		~BufferMaster()						{}
		
		void Reset()							{ unused = Data( start, unused.End() ); }
		void Reset( Data space )			{ unused = space; start = space.Start(); }
		
		ConstData Used() const				{ return ConstData( start, unused.Start() ); }
		const uint8 *UsedStart() const	{ return start; }

		uint32 TotalLength() const			{ return unused.End() - start; }
		uint32 UsedLength() const			{ return unused.Start() - start; }

		bool Fresh() const					{ return unused.Start() == start; }

		void ShiftOut( uint32 amount );
  };

#endif
