// ConstBufferMaster.h

#ifndef ConstBufferMaster_h
#define ConstBufferMaster_h

#ifndef ConstBuffer_h
#include "ConstBuffer.h"
#endif

/*
	A ConstBufferMaster is the owner's interface to a ConstBuffer.
*/

class ConstBufferMaster: public ConstBuffer
  {
	private:
		const uint8 *start;

		// not implemented:
			ConstBufferMaster( const ConstBufferMaster& );
			void operator=( const ConstBufferMaster& );
	
	public:
		ConstBufferMaster()
		  : ConstBuffer( ConstData() ),
			 start( 0 )
		  {}
		
		explicit ConstBufferMaster( ConstData space )
		  : ConstBuffer( space ),
			 start( space.Start() )
		  {}
		
		void Reset()							{ unused = ConstData( start, unused.End() ); }
		void Reset( ConstData space )		{ unused = space; start = space.Start(); }
		
		ConstData Used() const				{ return ConstData( start, unused.Start() ); }
		const uint8 *UsedStart() const	{ return start; }

		uint32 TotalLength() const			{ return unused.End() - start; }
		uint32 UsedLength() const			{ return unused.Start() - start; }

		bool Fresh() const					{ return unused.Start() == start; }
  };

#endif
