// Deferer.cp

#ifndef Deferer_h
#include "Deferer.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef Procedure_h
#include "Procedure.h"
#endif
#ifndef FakeDeferredTaskQueue_h
#include "FakeDeferredTaskQueue.h"
#endif
#ifndef ConfigureDeferredTaskFaking_h
#include "ConfigureDeferredTaskFaking.h"
#endif
#ifndef ApplicationWaker_h
#include "ApplicationWaker.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif

Deferer::Deferer()
  : action( 0 )
  {
	if ( useFakeDeferredTasks )
	  {
		FakeDeferredTaskQueue::The();
		ApplicationWaker::The();
	  }
	
	Assert( !DeferredTaskTime::IsNow() );
	
	block.dtParam = static_cast<uint32>( this );
	block.qType = dtQType;
	block.dtFlags = 0;
	block.dtReserved = 0;
	
	#if GENERATINGCFM
		static RoutineDescriptor ExecuteGlue =
			BUILD_ROUTINE_DESCRIPTOR( uppDeferredTaskProcInfo, Execute );
	#endif
	
	block.dtAddr = &ExecuteGlue;
  }

Deferer::~Deferer()
  {
	Assert( !DeferredTaskTime::IsNow() );
	Assert( !Pending() );
  }

void Deferer::Defer( const DeferredTaskTimeProcedure& toDefer )
  {
	Assert( action == 0 );
	action = &toDefer;
	
	if ( useFakeDeferredTasks )
	  {
		FakeDeferredTaskQueue::The().Install( block );
		ApplicationWaker::The().StartAlarm();
	  }
	 else
	  {
		DebugOSError( DTInstall( &block ) );
	  }
  }

void Deferer::Execute( Deferer *self )
  {
	DeferredTaskTime::Start();
	
	Assert( self->Pending() );
	const DeferredTaskTimeProcedure& action = *self->action;
	self->action = 0;
	action( DeferredTaskTime() );
	
	DeferredTaskTime::End();
  }

#if !GENERATINGCFM

pascal void Deferer::ExecuteGlue()
  {
	Deferer *self = static_cast<Deferer *>( RegisterA1() );
	
	A5 savedA5;
	self->a5.Restore();
	Execute( self );
	savedA5.Restore();
  }

#endif
