// CatInfoChanger.cp

#ifndef CatInfoChanger_h
#include "CatInfoChanger.h"
#endif

CatInfoChanger::CatInfoChanger()
  {
	#if GENERATINGCFM
		static RoutineDescriptor CompleteGlue =
			BUILD_ROUTINE_DESCRIPTOR( uppIOCompletionProcInfo, Complete );
	#endif

	hFileInfo.ioCompletion = &CompleteGlue;
	hFileInfo.ioResult = noErr;
  }

Task *CatInfoChanger::Get( const FSSpec& location )
  {
	Assert( !Running() );
	
	hFileInfo.ioVRefNum = location.vRefNum;
	hFileInfo.ioDirID = location.parID;
	hFileInfo.ioNamePtr = const_cast<StringPtr>( location.name );
	hFileInfo.ioFDirIndex = 0;
	getting = true;
		
	return this;
  }

Task *CatInfoChanger::Set( const FSSpec& location )
  {
	Assert( !Running() );
	
	hFileInfo.ioVRefNum = location.vRefNum;
	hFileInfo.ioDirID = location.parID;
	hFileInfo.ioNamePtr = const_cast<StringPtr>( location.name );
	hFileInfo.ioFDirIndex = 0;
	getting = false;
		
	return this;
  }

void CatInfoChanger::Launch()
  {
	Assert( !Running() );
	
	if ( getting )
		PBGetCatInfoAsync( this );
	 else
		PBSetCatInfoAsync( this );	 	
  }

void CatInfoChanger::Kill()
  {
  }

void CatInfoChanger::Complete( CInfoPBRec *block )
  {
	CatInfoChanger *self = static_cast< CatInfoChanger * >( block );
	self->Task::Complete();
  }

#if !GENERATINGCFM

void CatInfoChanger::CompleteGlue()
  {
	CInfoPBRec *block = RegisterA0();
	CatInfoChanger *self = static_cast< CatInfoChanger * >( block );
	
	A5 savedA5;
	self->a5.Restore();
	Complete( self );
	savedA5.Restore();
  }

#endif
