// FileOpener.h

#ifndef FileOpener_h
#define FileOpener_h

#ifndef HParamBlockTask_h
#include "HParamBlockTask.h"
#endif

class FileReadingPath;
class FileWritingPath;

class FileOpener: private HParamBlockTask
  {
	private:
		FileReadingPath *path;
		bool dataFork;
		
		void BuildParamBlock( const FSSpec&, SignedByte );
		
		virtual void Launch();
		virtual void Kill();
		
		virtual void AtCompletion();
		
	public:
		Task *OpenDataFork( const FSSpec&,
								  FileReadingPath&,
								  SignedByte permission = fsRdPerm );

		Task *OpenDataFork( const FSSpec&,
								  FileWritingPath&,
								  SignedByte permission = fsWrPerm );
		
		Task *OpenResourceFork( const FSSpec&,
										FileReadingPath&,
										SignedByte permission = fsRdPerm );
		
		Task *OpenResourceFork( const FSSpec&,
										FileWritingPath&,
										SignedByte permission = fsWrPerm );
		
		OSErr Error() const		{ return ioParam.ioResult; }
  };

#endif
