// PipePacket.cp

#ifndef PipePacket_h
#include "PipePacket.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

bool PipePacket::IsZero() const
  {
	return data == 0 && !flushing;
  }

void PipePacket::operator+=( PipePacket more )
  {
	Assert( data <= maxuint32 - more.data );
	data += more.data;
	
	Assert( !flushing );
	flushing = more.flushing;
  }

void PipePacket::operator-=( PipePacket less )
  {
	Assert( data >= less.data );
	data -= less.data;
	
	if ( less.flushing )
	  {
		Assert( flushing );
		flushing = false;
	  }
  }

void PipePacket::LimitTo( PipePacket limit )
  {
	if ( data > limit.data )
	  {
		data = limit.data;
		flushing = false;
	  }
	
	if ( !limit.flushing )
		flushing = false;
  }

void PipePacket::LimitData( uint32 limit )
  {
	if ( data > limit )
	  {
		data = limit;
		flushing = false;
	  }
  }

	