// Tee.h

#ifndef Tee_h
#define Tee_h

#ifndef TeeBase_h
#include "TeeBase.h"
#endif
#ifndef PipeOutput_h
#include "PipeOutput.h"
#endif

template < uint32 numberOfOutputs >
class Tee: private TeeBase
  {
	private:
		PipeOutputMaster outputs[ numberOfOutputs ];
		
	public:
		Tee( Data buffer )
		  : TeeBase( buffer, outputs, numberOfOutputs )
		  {
			InitializeOutputs();
		  }
		
		void Reset()						{ TeeBase::Reset(); }
		
		PipeInput& In()					{ return TeeBase::In(); }
		const PipeInput& In() const	{ return TeeBase::In(); }
		
		PipeOutput& Out( uint32 index )
		  {
			Assert( index < numberOfOutputs );
			return outputs[ index ];
		  }
		
		const PipeOutput& Out( uint32 index ) const
		  {
			Assert( index < numberOfOutputs );
			return outputs[ index ];
		  }
  };

#endif
