// TeeBase.h

#ifndef TeeBase_h
#define TeeBase_h

#ifndef DeferredTaskTime_h
#include "DeferredTaskTime.h"
#endif
#ifndef PipeInput_h
#include "PipeInput.h"
#endif

class PipeOutputMaster;

class TeeBase
  {
	protected:
		PipeInputMaster input;
		PipeOutputMaster *const outputs;
		const uint32 outputCount;
		const Data wholeRing;
		
		// not implemented:
			TeeBase( const TeeBase& );
			void operator=( const TeeBase& );
		
	protected:
		TeeBase( Data theWholeRing,
					PipeOutputMaster *theOutputs,
					uint32 theOutputCount );

		void Reset();
		void InitializeOutputs();
		
		PipeInput& In()						{ return input; }
		const PipeInput& In() const		{ return input; }
		
	public:
		void PushToOutputs( PipePacket );
		void PushToInput();

		bool OutputAuditsMatch() const;
		bool AuditTotalCorrect() const;
		bool SegmentEndsMatch() const;
  };

#endif
