// InputPump.h

#ifndef InputPump_h
#define InputPump_h

#ifndef TaskSequencer_h
#include "TaskSequencer.h"
#endif
#ifndef BufferMaster_h
#include "BufferMaster.h"
#endif
#ifndef Waiter_h
#include "Waiter.h"
#endif

class InStream;
class PipeInput;

class InputPump
  {
	private:
		InStream *stream;
		PipeInput *pipe;
		WaitLength pauseTime;
		BufferMaster readBuffer;
		Waiter wait;
		
		TaskSequencer<InputPump> sequence;
		typedef TaskStep<InputPump> Step;
		
		Step Accept( bool dying, DeferredTaskTime );
		Step Read( bool dying, DeferredTaskTime );
		Step Pass( bool dying, DeferredTaskTime );
		Step Pause( bool dying, DeferredTaskTime );
		Step Wake( bool dying, DeferredTaskTime );
		
	public:
		InputPump();
		
		Task *operator()( InStream&,
								PipeInput&,
								WaitLength pause = Millisecs( 10 ) );
  };

#endif
