// NullPump.cp

#ifndef NullPump_h
#include "NullPump.h"
#endif
#ifndef PipeOutput_h
#include "PipeOutput.h"
#endif

NullPump::NullPump()
  : pipe( 0 ),
	 sequence( *this )
  {
  }

Task *NullPump::operator()( PipeOutput& from )
  {
	pipe = &from;	
	return sequence.Start( Step( 0, &NullPump::Accept ) );
  }

TaskStep<NullPump> NullPump::Accept( bool dying, DeferredTaskTime )
  {
	Assert( pipe != 0 );
	
	if ( dying )
		return Step( 0 );
	
	return Step( pipe->Accept( 1 ), &NullPump::Pass );
  }

TaskStep<NullPump> NullPump::Pass( bool dying, DeferredTaskTime )
  {
	Assert( pipe != 0 );
	
	pipe->Buffer().AdvanceMark( pipe->Buffer().UnusedLength() );
	
	if ( dying )
		return Step( 0 );
	
	if ( pipe->Flushing() )
		return Step( pipe->AcknowledgeFlush(), &NullPump::Accept );
		
	return Step( pipe->Pass(), &NullPump::Accept );
  }
