// ObjectPump.h

#ifndef ObjectPump_h
#define ObjectPump_h

#ifndef TaskSequencer_h
#include "TaskSequencer.h"
#endif

class PipeOutput;
template < class DeliveryTime > class Pumpable;

template < class DeliveryTime >
class ObjectPump
  {
	public:
		typedef ObjectPump<DeliveryTime> Pump;
		typedef Pumpable<DeliveryTime> Target;
		typedef TaskStep< Pump > Step;
		
	private:
		PipeOutput *pipe;
		Target *target;
		
		TaskSequencer< Pump > sequence;

		Step Accept( bool dying, DeferredTaskTime );
		Step Deliver( bool dying, DeliveryTime );
		
	public:
		ObjectPump();
		
		Task *operator()( PipeOutput&, Target& );
  };

#endif
