// OutputPump.h

#ifndef OutputPump_h
#define OutputPump_h

#ifndef TaskSequencer_h
#include "TaskSequencer.h"
#endif
#ifndef ConstBufferMaster_h
#include "ConstBufferMaster.h"
#endif

class PipeOutput;
class OutStream;

class OutputPump
  {
	private:
		PipeOutput *pipe;
		OutStream *stream;
		ConstBufferMaster writeBuffer;
		
		TaskSequencer<OutputPump> sequence;
		typedef TaskStep<OutputPump> Step;
		
		Step Accept( bool dying, DeferredTaskTime );
		Step Write( bool dying, DeferredTaskTime );
		Step Pass( bool dying, DeferredTaskTime );
		Step AcknowledgeFlush( bool dying, DeferredTaskTime );
		
	public:
		OutputPump();
		
		Task *operator()( PipeOutput&, OutStream& );
  };

#endif
