// StreamToPipe.h

#ifndef StreamToPipe_h
#define StreamToPipe_h

#ifndef OutStream_h
#include "OutStream.h"
#endif
#ifndef TaskSequencer_h
#include "TaskSequencer.h"
#endif
#ifndef ConstBufferMaster_h
#include "ConstBufferMaster.h"
#endif

class PipeInput;

class StreamToPipe: public OutStream
  {
	private:
		PipeInput *pipe;
		ConstBufferMaster toWrite;
		
		TaskSequencer< StreamToPipe > sequence;
		typedef TaskStep<StreamToPipe> Step;
		
		Step BlockingAccept( bool dying, DeferredTaskTime );
		Step BlockingPass( bool dying, DeferredTaskTime );
		
		Step NonblockingAccept( bool dying, DeferredTaskTime );
		Step NonblockingPass( bool dying, DeferredTaskTime );
		
		virtual Task *BlockingWrite( ConstData );
		virtual Task *NonblockingWrite( ConstData );
		virtual Task *FlushingTask();
		
	public:
		StreamToPipe();
		StreamToPipe( PipeInput& thePipe );
		
		bool HasPipe() const						{ return pipe != 0; }
		void SetPipe( PipeInput& thePipe )	{ pipe = &thePipe; }
		void ClearPipe()							{ pipe = 0; }
  };

#endif
