// Race.h

#ifndef Race_h
#define Race_h

#ifndef TaskLife_h
#include "TaskLife.h"
#endif
#ifndef RaceBase_h
#include "RaceBase.h"
#endif

template < uint32 taskCount >
class Race: private RaceBase
  {
	private:		
		TaskLife lives[ taskCount ];
		
	protected:
		Task *tasks[ taskCount ];

		virtual void LaunchRacers( DeferredTaskTimeProcedure& completor )
		  {
			for ( uint32 i = 0; i < taskCount; i++ )
			  {
				Assert( tasks[i] != 0 );
				lives[i].Launch( tasks[i], completor );
			  }
		  }
		
		virtual void KillRacers()
		  {
			for ( uint32 i = 0; i < taskCount; i++ )
				lives[i].Kill();
		  }
		
		Task *GetReady( uint32 finishers )
		  {
			return RaceBase::GetReady( finishers, taskCount );
		  }
  };

class Race2: private Race<2>
  {
	public:
		Task *operator()( Task *task0,
								Task *task1,
								uint32 finishers )
		  {
			tasks[0] = task0;
			tasks[1] = task1;
			return GetReady( finishers );
		  }
  };

class Race3: private Race<3>
  {
	public:
		Task *operator()( Task *task0,
								Task *task1,
								Task *task2,
								uint32 finishers )
		  {
			tasks[0] = task0;
			tasks[1] = task1;
			tasks[2] = task2;
			return GetReady( finishers );
		  }
  };

class Race4: private Race<4>
  {
	public:
		Task *operator()( Task *task0,
								Task *task1,
								Task *task2,
								Task *task3,
								uint32 finishers )
		  {
			tasks[0] = task0;
			tasks[1] = task1;
			tasks[2] = task2;
			tasks[3] = task3;
			return GetReady( finishers );
		  }
  };

#endif
