// RaceBase.h

#ifndef RaceBase_h
#define RaceBase_h

#ifndef Task_h
#include "Task.h"
#endif
#ifndef BoundMethod_h
#include "BoundMethod.h"
#endif
#ifndef DeferredTaskTime_h
#include "DeferredTaskTime.h"
#endif

class RaceBase: private Task
  {
	private:
		uint32 racerCount;
		uint32 numberToLetFinish;
		uint32 numberFinished;
		bool launching;
		bool killAfterLaunch;
		
		void RacerFinished( DeferredTaskTime );
		BoundMethod1< RaceBase, DeferredTaskTime > racerFinished;
		
	protected:
		// provided to Task:
			virtual void Launch();
			virtual void Kill();
		
		// to be overridden:
			virtual void LaunchRacers( DeferredTaskTimeProcedure& ) = 0;
			virtual void KillRacers() = 0;
	
		Task *GetReady( uint32 numberToLetFinish,
							 uint32 racerCount );
			
	public:
		RaceBase();
  };	

#endif
