// InStream.h

#ifndef InStream_h
#define InStream_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Buffer_h
#include "Buffer.h"
#endif

class Task;

class InStream
  {
	private:
		Buffer *buffer;
		bool broken;
		bool ended;
		
	protected:
		InStream();
		//~InStream()		{}
		
		void Reset();
		
		virtual Task *BlockingRead( Data ) = 0;
		virtual Task *NonblockingRead( Data ) = 0;
		
		void ReportRead( uint32 length );
		void ReportFailure();
		void ReportEnd();
									  
	public:
		bool Broken() const			{ return broken; }
		bool Ended() const			{ return ended; }
		
		Task *ReadSome( Buffer& );
		Task *ReadAll( Buffer& );
  };

#endif
