// OutStream.h

#ifndef OutStream_h
#define OutStream_h

#ifndef Integers_h
#include "Integers.h"
#endif

class Task;
class ConstBuffer;
class ConstData;

class OutStream
  {
	private:
		ConstBuffer *buffer;
		bool broken;
		
	protected:
		OutStream();
		//~OutStream()		{}

		void Reset();
		
		virtual Task *BlockingWrite( ConstData ) = 0;
		virtual Task *NonblockingWrite( ConstData ) = 0;

		virtual Task *FlushingTask() = 0;
		
		void ReportWrite( uint32 length );
		void ReportFailure();
		
	public:
		bool Broken() const			{ return broken; }

		Task *WriteSome( ConstBuffer& );
		Task *WriteAll( ConstBuffer& );

		Task *Flush();
  };

#endif
