// AtomicFlag.h

#ifndef AtomicFlag_h
#define AtomicFlag_h

/***
	 The guarantees this class gives are weaker than you might think:
	 
	 If one TestAndSet is interrupted by another, only one of them
	 will report a true flag.  Similarly, if one TestAndClear is
	 interrupted by another, only one will see a false flag.
***/

class AtomicFlag
  {
	private:
		volatile bool first;
		volatile bool second;
	
	public:
		AtomicFlag( bool value )
		  : first( value ),
			 second( value )
		  {}
				
		bool TestAndSet();
		bool TestAndClear();
  };

#endif
