// Sleeper.cp

#ifndef Sleeper_h
#include "Sleeper.h"
#endif

Sleeper::Sleeper()
  : complete( true )
  {
  }

Task *Sleeper::operator()()
  {
	bool wasComplete = complete.TestAndClear();
	Assert( wasComplete );
	
	launched = false;
	woken = false;
	
	return this;
  }

void Sleeper::Launch()
  {
	launched = true;
	
	if ( woken )
		if ( complete.TestAndSet() )
			Complete();
  }

void Sleeper::Kill()
  {
	woken = true;
	if ( launched )
		if ( complete.TestAndSet() )
			Complete();
  }
