// Sleeper.h

#ifndef Sleeper_h
#define Sleeper_h

#ifndef Task_h
#include "Task.h"
#endif
#ifndef AtomicFlag_h
#include "AtomicFlag.h"
#endif

/*
	A Sleeper produces a task which sleeps until it is killed
	or woken.  To make timing things easier, a Sleeper which
	is woken between priming time and Launch() will complete
	immediately when it is launched.
*/

class Sleeper: private Task
  {
	private:
		AtomicFlag complete;
		volatile bool launched;
		volatile bool woken;
		
	protected:
		virtual void Launch();
		virtual void Kill();
	
	public:
		Sleeper();
		
		Task *operator()();
		void Wake()				{ Sleeper::Kill(); }
  };

#endif
