// Waiter.cp

#ifndef Waiter_h
#include "Waiter.h"
#endif

Waiter::Waiter()
  : incomplete( false ),
	 time( Millisecs( 0 ) ),
	 killing( false )
  {
	#if GENERATINGCFM
		static RoutineDescriptor CompleteGlue =
			BUILD_ROUTINE_DESCRIPTOR( uppTimerProcInfo, Complete );
	#endif

	tmAddr = &CompleteGlue;
  }

QElem *Waiter::QElement()
  {
	return reinterpret_cast<QElem*>( static_cast<TMTask*>( this ) );
  }

Task *Waiter::operator()( WaitLength theTime )
  {
	Assert( !incomplete );
	Assert( !killing );
	time = theTime;
	return this;
  }

void Waiter::Launch()
  {
	Assert( !incomplete );
	Assert( !killing );
	qLink = 0;
	tmWakeUp = 0;
	tmCount = 0;
	tmReserved = 0;
	incomplete = true;
	InsTime( QElement() );
	PrimeTime( QElement(), time.Value() );
  }

void Waiter::Kill()
  {
	if ( !incomplete || killing )
		return;
	
	killing = true;
	
	RmvTime( QElement() );
	
	if ( incomplete )
	  {
		incomplete = false;
		Task::Complete();
	  }
	
	killing = false;
  }

pascal void Waiter::Complete( TMTask *task )
  {
	Waiter *self = static_cast<Waiter *>( task );
	
	Assert( self->incomplete );
	RmvTime( self->QElement() );
	self->incomplete = false;
	self->Task::Complete();
  }

#if !GENERATINGCFM

pascal void Waiter::CompleteGlue()
  {
	TMTask *task = static_cast<TMTask *>( RegisterA1() );
	Waiter *self = static_cast<Waiter *>( task );
	
	A5 savedA5;
	self->a5.Restore();
	Complete( self );
	savedA5.Restore();
  }

#endif
