// Waiter.h

#ifndef Waiter_h
#define Waiter_h

#ifndef __TIMER__
#include <Timer.h>
#endif
#ifndef A5_h
#include "A5.h"
#endif
#ifndef Task_h
#include "Task.h"
#endif
#ifndef WaitLength_h
#include "WaitLength.h"
#endif

/*
	A Waiter produces a Time Manager Task.
	You call it like this:
		Waiter wait;
		wait( Millisecs( 5 ) )
		or 
		wait( Microsecs( 5 ) )
*/

class Waiter: private Task,
				  private TMTask
  {
	private:
		WaitLength time;
		bool incomplete;
		bool killing;
		A5 a5;
		
		static pascal void Complete( TMTask * );
		static pascal void CompleteGlue();
		
		QElem *QElement();
		
	protected:
		virtual void Launch();
		virtual void Kill();
		
	public:
		Waiter();
		
		Task *operator()( WaitLength );
  };

#endif
