//
//	DemoGraphicsImporters.r
//

#include "DemoGraphicsImporters.h"

#define WIND_RezTemplateVersion 1
#define ALRT_RezTemplateVersion 0
#define SystemSevenOrLater 1
#define SystemSevenOrBetter 1

#include "ConditionalMacros.r"
#include "MacTypes.r"
#include "Finder.r"
#include "Dialogs.r"
#include "Menus.r"

resource 'WIND' (kDemoWindowID, purgeable) {
	//{41, 3, 475, 580}, // for 640x480
	{45, 10, 590, 790},	// for 800x600
	documentProc,
	invisible,
	goAway,
	0x0,
	"Fun with Graphics Importers",
	noAutoCenter
};

resource 'MENU' (mApple, preload) {
	mApple,
	textMenuProc,
	allEnabled,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About This Demo", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (mFile, preload) {
	mFile,
	textMenuProc,
	0x000B,
	enabled,
	"File",
	{	
		/* [1] */
		"Open", noIcon, "O", noMark, plain,
		/* [2] */
		"Close", noIcon, "W", noMark, plain,
		/* [3] */
		"-", noIcon, noKey, noMark, plain,
		/* [4] */
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (mEdit, preload) {
	mEdit,
	textMenuProc,
	0x7FFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Cut", noIcon, "X", noMark, plain,
		/* [4] */
		"Copy", noIcon, "C", noMark, plain,
		/* [5] */
		"Paste", noIcon, "V", noMark, plain,
		/* [6] */
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (mMatrix, preload) {
	mMatrix,
	textMenuProc,
	0x7FF7,
	enabled,
	"Matrix",
	{	
		/* [1] */
		"Translate", noIcon, noKey, noMark, plain,
		/* [2] */
		"Rotate", noIcon, noKey, noMark, plain,
		/* [3] */
		"Distort", noIcon, noKey, noMark, plain,
		/* [4] */
		"-", noIcon, noKey, noMark, plain,
		/* [5] */
		"Show Code", noIcon, noKey, noMark, plain,
		/* [6] */
		"Show Matrix", noIcon, noKey, noMark, plain,
		/* [7] */
		"Show Points", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (mComposition, preload) {
	mComposition,
	textMenuProc,
	0x7FFF,
	enabled,
	"Composition",
	{	
		/* [1] */
		"Change Image", noIcon, noKey, noMark, plain,
		/* [2] */
		"Change Background", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (mTransferMode, preload) {
	mTransferMode,
	textMenuProc,
	0x7EFF,
	enabled,
	"Transfer Mode",
	{	
		/* [1] */
		"Dither Copy", noIcon, noKey, noMark, plain,
		/* [2] */
		"Copy", noIcon, noKey, noMark, plain,
		/* [3] */
		"Blend", noIcon, noKey, noMark, plain,
		/* [4] */
		"Transparent", noIcon, noKey, noMark, plain,
		/* [5] */
		"Straight Alpha", noIcon, noKey, noMark, plain,
		/* [6] */
		"Premul White Alpha", noIcon, noKey, noMark, plain,
		/* [7] */
		"Premul Black Alpha", noIcon, noKey, noMark, plain,
		/* [8] */
		"Straight Alpha Blend", noIcon, noKey, noMark, plain,
		/* [9] */
		"-", noIcon, noKey, noMark, plain,
		/* [10] */
		"Choose OpColor", noIcon, noKey, noMark, plain
	}
};

resource 'MBAR' (kMenuBarID, preload) {
	{	
		mApple,
		mFile,
		mEdit,
		mMatrix,
		mComposition,
		mTransferMode
	}
};
